#!/usr/bin/env python
# -*- coding: UTF-8 -*-
"""
 Author: enen92 

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
"""

from directory import *
import urllib, json,re,os


def get_playlists():
	url = 'https://www.googleapis.com/youtube/v3/playlists?part=snippet&channelId=UCyz1mAW3FzQL0se1GW8O3zA&maxResults=50&key=AIzaSyCQbXmFybItk4Rjx-cgSB1D7YUk9Qncw9E'
	raw = urllib.urlopen(url)
	resp = json.load(raw)
	raw.close()
	if resp["items"]:
		for item in resp["items"]:
			playlist_name = item["snippet"]["title"]
			playlist_url = item["id"]
			playlist_img = item["snippet"]["thumbnails"]["default"]["url"]
			addDir('[B]'+playlist_name.encode('utf-8')+'[/B] ',playlist_url,3, playlist_img,1,1)


def return_youtubevideos(page,mode,token,playlist_id):

	items_per_page = int(selfAddon.getSetting('items_per_page'))

	if page != 1:
		url = 'https://www.googleapis.com/youtube/v3/playlistItems?part=id,snippet,contentDetails&maxResults='+str(items_per_page)+'&playlistId='+playlist_id+'&key=AIzaSyCQbXmFybItk4Rjx-cgSB1D7YUk9Qncw9E&pageToken='+token
	else:
		url = 'https://www.googleapis.com/youtube/v3/playlistItems?part=id,snippet,contentDetails&maxResults='+str(items_per_page)+'&playlistId='+playlist_id+'&key=AIzaSyCQbXmFybItk4Rjx-cgSB1D7YUk9Qncw9E'
	raw = urllib.urlopen(url)
	resp = json.load(raw)
	raw.close()
	try: nextpagetoken = resp["nextPageToken"]
	except: nextpagetoken = ''
	try: availablevideos = resp["pageInfo"]["totalResults"]
	except: availablevideos = 1
	returnedVideos = resp["items"]
	totalvideos = len(returnedVideos)
	totalpages = int((float(availablevideos)/items_per_page))
	for video in returnedVideos:
		title = video["snippet"]["title"]
		plot = video["snippet"]["description"]
		aired = video["snippet"]["publishedAt"]
		try: thumb = video["snippet"]["thumbnails"]["high"]["url"]
		except: thumb = ''
		videoid = video["contentDetails"]["videoId"]
		try: 
			date = re.compile('(.+?)-(.+?)-(.+?)T').findall(aired)[0]
			date = date[0]+'-'+date[1]+'-'+date[2]
		except: date = ''
		try:
			if 'episode' in title.lower() or '#' in title.lower():
				episode = re.compile('(\d+)').findall(title)[0]
			else: episode = ''
		except: episode = ''
		if os.path.exists(os.path.join(watchedfolder,str(videoid)+'.txt')) : playcount = 1
		else: playcount = 0
		
		infolabels = {'plot':plot,'aired':date,'tvshowtitle':'Adrenaline','title':title,'originaltitle':title,'status':'Continuing','cast':('',''),'castandrole':('',''),'episode':episode,'playcount':playcount}
		
		addEpisode(title.encode('utf-8'),videoid,5,thumb,page,totalvideos,infolabels,folder=False)

	#check if more pages do exist
	#if 
	
	
	if totalpages > 1 and (page+1) <= totalpages:
		addDir('[B]'+translate(30010)+'[/B] '+str(page)+'/'+str(totalpages),nextpagetoken,mode, '',page+1,1)
	xbmcplugin.setContent(int(sys.argv[1]), 'episodes')

